 #include "stlexam.h"
 #pragma hdrstop
 /**************************************************************************
 *
 * io_iter.cpp - Example program of iterator . See Class Reference Section
 *
 ***************************************************************************
 *
 * (c) Copyright 1994, 1998 Rogue Wave Software, Inc.
 * ALL RIGHTS RESERVED
 *
 * The software and information contained herein are proprietary to, and
 * comprise valuable trade secrets of, Rogue Wave Software, Inc., which
 * intends to preserve as trade secrets such software and information.
 * This software is furnished pursuant to a written license agreement and
 * may be used, copied, transmitted, and stored only in accordance with
 * the terms of such license and with the inclusion of the above copyright
 * notice.  This software and information or any other copies thereof may
 * not be provided or otherwise made available to any other person.
 *
 * Notwithstanding any other lease or license that may pertain to, or
 * accompany the delivery of, this computer software and information, the
 * rights of the Government regarding its use, reproduction and disclosure
 * are as set forth in Section 52.227-19 of the FARS Computer
 * Software-Restricted Rights clause.
 * 
 * Use, duplication, or disclosure by the Government is subject to
 * restrictions as set forth in subparagraph (c)(1)(ii) of the Rights in
 * Technical Data and Computer Software clause at DFARS 252.227-7013.
 * Contractor/Manufacturer is Rogue Wave Software, Inc.,
 * P.O. Box 2328, Corvallis, Oregon 97339.
 *
 * This computer software and information is distributed with "restricted
 * rights."  Use, duplication or disclosure is subject to restrictions as
 * set forth in NASA FAR SUP 18-52.227-79 (April 1985) "Commercial
 * Computer Software-Restricted Rights (April 1985)."  If the Clause at
 * 18-52.227-74 "Rights in Data General" is specified in the contract,
 * then the "Alternate III" clause applies.
 *
 **************************************************************************/   
#include <iterator>
#include <vector>
#include <numeric>

#ifdef _RW_STD_IOSTREAM
#include <iostream>
#else
#include <iostream.h>
#endif     

int main ()
{
#ifndef _RWSTD_NO_NAMESPACE
  using namespace std;
#endif

  vector<int,allocator<int> > d;
  int total = 0;
  //
  // Collect values from cin until end of file
  // Note use of default constructor to get ending iterator
  //
  cout << "Enter a sequence of integers (eof to quit): " ;
  copy(istream_iterator<int,char,char_traits<char>,ptrdiff_t >(cin),
       istream_iterator<int,char,char_traits<char>,ptrdiff_t >(),
       inserter(d,d.begin()));
  //
  // stream the whole vector and the sum to cout
  //
  copy(d.begin(),d.end()-1,
       ostream_iterator<int,char,char_traits<char> >(cout," + "));
  if (d.size())
    cout << *(d.end()-1) << " = " <<  
      accumulate(d.begin(),d.end(),total) << endl;
  return 0;
}

